% test de l'appel à la fonctiojn test...


%% initialisation

clear all

addpath('..')
%validation parameters

opt.nbclass=3;
opt.sub=1;
opt.framerate=10;

f=40;
opt.f=f;
opt.decy=0;
opt.props=[1 1 1];

% params to validate


opt.loop=1;

opt.sel=0.3;
opt.tosel=[1 1 1 1 1 1 1 1 1];

opt.seed=1;

opt.todo=[1 1 1 1 1 1 1 0 0];


d=13;
% classification parameters
options.f=f; % : legth of the filter

%options.decy =floor(f/2);%: y time shift...
%options.decy =11;%: y time shift...
options.decy =opt.decy;%: y time shift...

options.F=ones(f,d)/(f); %: initialisation of the filter
%options.F=zeros(f,d)/(f); %: initialisation of the filter
%options.F(options.decy,:)=1;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =20 ;%: log informatioouns
options.stopvarx=[0];% : threshold for stopping on F changes
options.stopvarj=[1e-3];
options.usegolden=1;
options.goldensearch_deltmax=.01;
options.goldensearch_stepmax=1;
options.numericalprecision=1e-3;

linear=0;
if linear
    options.kernel='linear';
    options.kerneloption=1;
    options.C = 1e-3; %: C value for svm
    options.regnorm2=1e-2;%[2.25e-2];
    options.regnorm12=0e-3;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
    
    % validation spaces
    opt.cvalues=logspace(2,4,10);
    opt.sigmavalues=linspace(5,100,3);
    opt.filtercvalues=logspace(2,5,5);
    opt.regnorm2=logspace(2,7,5);
    opt.regnorm12=logspace(1,3,3);
else
    options.kernel='gaussian';
    options.kerneloption=1;
    options.C = 1e3; %: C value for svm
    options.regnorm2=1e2;%[2.25e-2];
    options.regnorm12=0e2;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
end 

opt.linear=linear;
                     


% GMM parameters
optionsgmm.nbgauss=[2];
optionsgmm.nbiterem=50;
optionsgmm.nbiterkmeans=20;
optionsgmm.verbose=0;



% options gmkl
options.kerneltype=1; % noyaux multiplicatifs


% params to validate

nbval=10;
nbvalfilter=5;

opt.cvalues=logspace(0,4,nbval);
opt.sigmavalues=logspace(-1,2,nbval);
opt.filtercvalues=logspace(0,5,nbvalfilter);
opt.regnorm2=logspace(1,3,nbvalfilter);
opt.regnorm12=logspace(1,3,nbvalfilter);
opt.gammavalues=logspace(-1,2,nbvalfilter);
opt.nbgaussgmm=[1:5];


opt.options=options;
opt.optionsgmm=optionsgmm;


filename=  GetBCIFilename(opt);

%set the functions...
opt.load_data_func=@GetDataBCI;
opt.get_filename_func=@GetBCIFilename;

%         svm svmfilt wsvm ssvml2 hmm

listf=[ 20 35 50]

%%



for l=1:length(listf)

    opt.f=listf(l);
  %  opt.decy=ceil(listf(l)/2);
  
  for m=1:3
     opt.sub=m; 
CalcCompMethData(opt)
  end
end



%%


opt.sub=1;
opt.f=10
filename=  GetBCIFilename(opt);
load(['results/' filename '.mat'])

if opt.todo(1)~=0 res_svm=res_svm{1}; end
if opt.todo(2)~=0 res_svmf=res_svmf{1}; end
if opt.todo(3)~=0 res_filter=res_filter{1}; end
if opt.todo(4)~=0 res_filters=res_filters{1}; end
if opt.todo(5)~=0 res_gmm=res_gmm{1}; end
if opt.todo(6)~=0 res_filtergmm=res_filtergmm{1}; end
if opt.todo(7)~=0 res_tdesvm=res_tdesvm{1}; end
if opt.todo(8)~=0 res_tdegmkl=res_tdegmkl{1}; end
if opt.todo(9)~=0 res_tdegroup=res_tdegroup{1}; end

                  fprintf('|Method    |Test Error| AUC      |Error Vit.  |\n')
                  fprintf('-----------------------------------------------\n')
if opt.todo(1)~=0 fprintf('|SVM       | %1.6f | %1.6f | %1.8f |\n',m_err_svm,m_auc_svm,m_err_svm_mm); end
if opt.todo(2)~=0 fprintf('|SVMF      | %1.6f | %1.6f | %1.8f |\n',m_err_svmf,m_auc_svmf,m_err_svmf_mm); end
if opt.todo(3)~=0 fprintf('|FilterSVM | %1.6f | %1.6f | %1.8f |\n',m_err_filter,m_auc_filter,m_err_filter_mm); end
if opt.todo(4)~=0 fprintf('|FilterSVMS| %1.6f | %1.6f | %1.8f |\n',m_err_filters,m_auc_filters,m_err_filters_mm); end
if opt.todo(5)~=0 fprintf('|GMM       | %1.6f | %1.6f | %1.8f |\n',m_err_gmm,m_auc_gmm,m_err_gmm_mm); end
if opt.todo(6)~=0 fprintf('|FilterGMM | %1.6f | %1.6f | %1.8f |\n',m_err_filtergmm,m_auc_filtergmm,m_err_filtergmm_mm); end
if opt.todo(7)~=0 fprintf('|TDESVM    | %1.6f | %1.6f | %1.8f |\n',m_err_tdesvm,m_auc_tdesvm,m_err_tdesvm_mm); end
if opt.todo(8)~=0 fprintf('|TDEGMKL   | %1.6f | %1.6f | %1.8f |\n',m_err_tdegmkl,m_auc_tdegmkl,m_err_tdegmkl_mm); end
if opt.todo(9)~=0 fprintf('|GROUPSVM  | %1.6f | %1.6f | %1.8f |\n',m_err_tdegroup,m_auc_tdegroup,m_err_tdegroup_mm); end




%% getresults

opt.sub=3;
getres.filename=@GetBCIFilename;
getres.opt=opt;
getres.var=listf;
getres.varname='f';
getres.getvars=getvarslist(opt,[1 0 0]);

res=GetMultiresults(getres)



%% visu results
figure(1)

linew=2;
msize=14;
clf
hold on

if opt.todo(1)~=0 ,plot(res.var,[res.m_err_svm],'k+-','linewidth',linew,'Markersize',msize), end
if opt.todo(2)~=0 ,plot(res.var,[res.m_err_svmf],'b*-','linewidth',linew,'Markersize',msize), end
if opt.todo(3)~=0 ,plot(res.var,[res.m_err_filter],'ro-','linewidth',linew,'Markersize',msize), end
if opt.todo(4)~=0 ,plot(res.var,[res.m_err_filters],'r+-','linewidth',linew,'Markersize',msize), end
if opt.todo(5)~=0 ,plot(res.var,[res.m_err_gmm],'y+-','linewidth',linew,'Markersize',msize); end
if opt.todo(6)~=0 ,plot(res.var,[res.m_err_filtergmm],'g+-','linewidth',linew,'Markersize',msize); end
if opt.todo(7)~=0 ,plot(res.var,[res.m_err_tdesvm],'c+-','linewidth',linew,'Markersize',msize); end
if opt.todo(8)~=0 ,plot(res.var,[res.m_err_tdegmkl],'m+-','linewidth',linew,'Markersize',msize); end
if opt.todo(9)~=0 ,plot(res.var,[res.m_err_tdegroup],'m+-','linewidth',linew,'Markersize',msize); end

hold off
%errorbar(repmat(nbtot',1,5),[err0' erravg' errssvm' errwsvm' errmarkov'],[serr0' serravg' serrssvm' serrwsvm' serrmarkov'])

set(gca,'FontSize',12) 
xlabel('filter size')
%ylim([0.3 0.51])
title({'Test error with different ' getres.varname ' value'},'FontSize',14) 
%legend('SVM','Avg-SVM','KF-SVM','SVM-Vit','Avg-SVM-Vit','KF-SVM-Vit')
legs={'SVM','SVMF','FilterSVM','SFilterSVM','GMM','FilterGMM','TDESVM','TDEgmkl','GROUP-SVM'};

legend(legs{logical(opt.todo(:))})