function CalcBCIResults(opt)



%% loading


subject=opt.sub;
addpath('..')
filename=['results/' GetBCIFilename(opt) '.mat'];
tfilename=['results/' GetBCIFilename(opt) '.log'];
%taille=[1000 100];
%[X,Y,Xte,Yte]=GetDataBCI_III(subject,num,taille);
%[X,Y,Xte,Yte]=GetDataBCI_III2(subject);
[X,Y,Xte,Yte,Xval,Yval]=GetDataBCI_IIIVal2(subject);

%X=X(1:taille(1),:);floor
%Y=Y(1:taille(1),:);

%X=[X;Xval];
%Y=[Y;Yval];

%Xte=Xval;
%Yte=Yval;

[Xtemp,mx,vx]=gnormalise([X; Xval]);
clear Xtemp
Mx=ones(size(X,1),1)*mx;
Vx=ones(size(X,1),1)*vx;
X=(X-Mx)./Vx;

Mx=ones(size(Xte,1),1)*mx;
Vx=ones(size(Xte,1),1)*vx;
Xte=(Xte-Mx)./Vx;

Mx=ones(size(Xval,1),1)*mx;
Vx=ones(size(Xval,1),1)*vx;
Xval=(Xval-Mx)./Vx;

clear Mx Vx



diary(tfilename)
diary on


%% params


d=size(X,2);
nbpts=size(X,1);
%Y=Yd(:,1);
%Yte=Ydte(:,1);
f=opt.f;
% options.f=opts.f; % : legth of the filter
%  
%  options.F=[ones(f,d)/(f)]; %: initialisation of the filter
%  
% options.decy =opts.decy;%: y time shift...
% %options.decy =0;%: y time shift...
%  
%  options.C = .001; %: C value for svm
%  options.verbose= 1;%: print everything
%  options.log =1;%: log informations 
%  options.nbitermax =20 ;%: log informations 
%  options.stopcF=[d 1e-3];% : threshold for stopping on F changes
%  options.stopcJ=[1 0.0001];
%  options.sparsesig=0e6;%5e4;%1e5;[0 logspace(0,8,4)]
%  options.usegolden=1;
%  options.goldensearch_deltmax=.001;
%  options.goldensearch_stepmax=d;
%  options.numericalprecision=1e-9;
%  options.regdiff=0.;%.1.1
%  options.regnorm2=1e-2;
%  options.regnorm12=0e5;
%  options.uniquefilter=0;

options=opt.options;               


options.F=ones(opt.f,size(X,2))/opt.f;

cvalues=opt.cvalues;
sigmavalues=opt.sigmavalues;
regnorm2=opt.regnorm2;
regnorm12=opt.regnorm12;
filtercvalues=opt.filtercvalues;
%regnorm2=opt.regnorm2;


%options.F=zeros(f,d)/f; options.F(options.decy+1,:)=1;
Fmavg=ones(f,d)/(f);


if opt.KD~=0
    KD=opt.KD;
    X=avgdownsampling(X,KD);
Xte=avgdownsampling(Xte,KD);
Xval=avgdownsampling(Xval,KD);
Y=downsample(Y,KD,ceil(KD/2));
Yte=downsample(Yte,KD,ceil(KD/2));
Yval=downsample(Yval,KD,ceil(KD/2));

    
end

todo=opt.todo
% svm svmfilt wsvm ssvml2 hmm


%% loop!

%sigsvms={};
res_svm=[];
err_svm=[];
auc_svm=[];


    
    
    %% HMM parameters learning
    
    
prior=GetMarkovPrior(Y);
transmat=GetMarkovTransitionMatrix(Y);


    if todo(1)~=0
        
        disp('SVM Validation')
        
        
        options.verbose=0;

        opts=[];

        % validation options
        opts.params{1}='C';
        opts.values{1}=cvalues;

        if  ~isfield(opt,'nosigma')
        opts.params{2}='kerneloption';
        opts.values{2}=sigmavalues;
        end

        opts.learning=@svmclass2;
        opts.valmodels=@svmval2;
        opts.warmstart=@warmstart_svmclass2;


        [svm,optionssvm,LOGsvm]=validation_loop(X,Y,Xval,Yval,options,opts);

        ypred=svmval2(Xte,svm);

        res_svm=get_precision(Yte,ypred);
        err_svm=res_svm.err;
        %auc_svmf=res_svmf.auc;
        

        
        % HMM !!
         svm=svmtoproba([X;Xval],[Y;Yval],svm);
         yprob=psvmval2(Xte,svm);

         path = viterbi_path(prior, transmat, [yprob]');
         ymm=(path)';
            
         err_svm_mm=sum(ymm==Yte)/length(Yte);
         
         
         fprintf('| Err_SVM | Err_SVM_MM |\n')
         fprintf('| %1.6f | %1.8f |\n',err_svm,err_svm_mm)
         

    end




    %% calcul pour le svm filtré

    if todo(2)~=0
        
        disp('SVMF Validation')
        
        
        options.verbose=0;

        opts=[];

        % validation options
        opts.params{1}='C';
        opts.values{1}=cvalues;

        if  ~isfield(opt,'nosigma')
        opts.params{2}='kerneloption';
        opts.values{2}=sigmavalues;
        end

        opts.learning=@svmclass2;
        opts.valmodels=@svmval2;
        opts.warmstart=@warmstart_svmclass2;


        [svmf,optionssvmf,LOGsvmf]=validation_loop(mfilter(Fmavg,X,options.decy),Y,mfilter(Fmavg,Xval,options.decy),Yval,options,opts);

        ypred=svmval2(mfilter(Fmavg,Xte,options.decy),svmf);

        res_svmf=get_precision(Yte,ypred);
        err_svmf=res_svmf.err;
        %auc_svmf=res_svmf.auc;
        

        
        % HMM !!
         svmf=svmtoproba(mfilter(Fmavg,[X;Xval],options.decy),[Y;Yval],svmf);
         yprob=psvmval2(mfilter(Fmavg,Xte,options.decy),svmf);

         path = viterbi_path(prior, transmat, [yprob]');
         ymm=(path)';
            
         err_svmf_mm=sum(ymm==Yte)/length(Yte);
         
         
         fprintf('| Err_SVMF | Err_SVMF_MM |\n')
         fprintf('| %1.6f | %1.8f |\n',err_svmf,err_svmf_mm)
         
         options.kerneloption=optionssvmf.kerneloption;


    end
    
      %% calcul pour le FilterSVM

    if todo(3)~=0
        
        disp('FilterSVM Validation')
        
        
        options.verbose=0;

        opts=[];

        % validation options
        opts.params{1}='C';
        opts.values{1}=filtercvalues;

        opts.params{2}='regnorm2';
        opts.values{2}=regnorm2;

        opts.learning=@filtersvmclass;
        opts.valmodels=@filtersvmval;
        opts.warmstart=[];


        [filtersvm,optionsfilter,LOGfilter]=validation_loop(X,Y,Xval,Yval,options,opts);

        [ypred,ypredval]=filtersvmval(Xte,filtersvm);

        res_filter=get_precision(Yte,ypredval);
        err_filter=res_filter.err;
        %auc_filter=res_filter.auc;
        

        
        % HMM !!
         filtersvm=filtersvmtoproba([X;Xval],[Y;Yval],filtersvm);
         yprob=pfiltersvmval(Xte,filtersvm);

         path = viterbi_path(prior, transmat, [yprob]');
         ymm=(path)';
            
         err_filter_mm=sum(ymm==Yte)/length(Yte);
         

         
         fprintf('| Err_Filter  | Err_Filter_MM |\n')
         fprintf('| %1.6f | %1.8f |\n',err_filter,err_filter_mm)

    end
    
    


%% calc
diary off

%% sauvegarde des résultats dan un fichier

clear X Xte Xval Y Yte Yval

save(filename)

