function launcher_BCI(vec)


addpath('..')
%validation parameters

opt.nbclass=3;
opt.sub=1;
opt.framerate=10;

f=40;
opt.f=f;
opt.decy=0;
opt.props=[1 1 1];

% params to validate


opt.loop=1;

opt.sel=0.3;
opt.tosel=[1 1 1 1 1 1 1 1 1];

opt.seed=1;

opt.todo=[1 1 1 1 1 1 1 0 0];


d=13;
% classification parameters
options.f=f; % : legth of the filter

%options.decy =floor(f/2);%: y time shift...
%options.decy =11;%: y time shift...
options.decy =opt.decy;%: y time shift...

options.F=ones(f,d)/(f); %: initialisation of the filter
%options.F=zeros(f,d)/(f); %: initialisation of the filter
%options.F(options.decy,:)=1;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =20 ;%: log informatioouns
options.stopvarx=[0];% : threshold for stopping on F changes
options.stopvarj=[1e-3];
options.usegolden=1;
options.goldensearch_deltmax=.01;
options.goldensearch_stepmax=1;
options.numericalprecision=1e-3;

linear=0;
if linear
    options.kernel='linear';
    options.kerneloption=1;
    options.C = 1e-3; %: C value for svm
    options.regnorm2=1e-2;%[2.25e-2];
    options.regnorm12=0e-3;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
    
    % validation spaces
    opt.cvalues=logspace(2,4,10);
    opt.sigmavalues=linspace(5,100,3);
    opt.filtercvalues=logspace(2,5,5);
    opt.regnorm2=logspace(2,7,5);
    opt.regnorm12=logspace(1,3,3);
else
    options.kernel='gaussian';
    options.kerneloption=1;
    options.C = 1e3; %: C value for svm
    options.regnorm2=1e2;%[2.25e-2];
    options.regnorm12=0e2;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
end 

opt.linear=linear;
                     


% GMM parameters
optionsgmm.nbgauss=[2];
optionsgmm.nbiterem=50;
optionsgmm.nbiterkmeans=20;
optionsgmm.verbose=0;



% options gmkl
options.kerneltype=1; % noyaux multiplicatifs


% params to validate

nbval=10;
nbvalfilter=5;

opt.cvalues=logspace(0,4,nbval);
opt.sigmavalues=logspace(-1,2,nbval);
opt.filtercvalues=logspace(0,5,nbvalfilter);
opt.regnorm2=logspace(1,3,nbvalfilter);
opt.regnorm12=logspace(1,3,nbvalfilter);
opt.gammavalues=logspace(-1,2,nbvalfilter);
opt.nbgaussgmm=[1:5];


opt.options=options;
opt.optionsgmm=optionsgmm;




%set the functions...
opt.load_data_func=@GetDataBCI;
opt.get_filename_func=@GetBCIFilename;

%         svm svmfilt wsvm ssvml2 hmm

listf=[ 20 35 50]

%%




    opt.f=listf(vec(1));

     opt.sub=vec(2); 
     
     filename=  GetBCIFilename(opt)
     
    CalcCompMethData(opt)

