function [X,Y,idx,Yval,idxval,Yte,idxte]=Get_KFC_Data(nbpts,pos,neg)
% X : big image...
% Y labels (-1:1)
% idxs (indexes corresponding to the labels
% nbpts props of app/val/test
% pos positive labels
% negative labels...

nbpts=nbpts/sum(nbpts);

marge=8;

load('KFC_data.mat');
Yt=[];
idxt=[];
for i=pos
    temp=AllSpeData{i};
    idxt=[idxt; temp(:,2:-1:1)];
    Yt=[Yt; ones(size(temp,1),1)];
end
    
for i=neg
    temp=AllSpeData{i};
    idxt=[idxt; temp(:,2:-1:1)];
    Yt=[Yt; -ones(size(temp,1),1)];
end


int_nb=cumsum(floor(length(Yt)*nbpts));

perm=randperm(length(Yt));


imin=max(1,min(idxt(:,1))-marge);
imax=min(max(idxt(:,1))+marge,size(X,1));
jmin=max(1,min(idxt(:,2))-marge);
jmax=min(max(idxt(:,2))+marge,size(X,2));

X=X(imin:imax,jmin:jmax,:);

idxt=idxt-repmat([imin jmin],size(idxt,1),1);

Y=Yt(perm(1:int_nb(1)),:);
idx=idxt(perm(1:int_nb(1)),:);
Yval=Yt(perm(int_nb(1)+1:int_nb(2)),:);
idxval=idxt(perm(int_nb(1)+1:int_nb(2)),:);
Yte=Yt(perm(int_nb(2)+1:int_nb(3)),:);
idxte=idxt(perm(int_nb(2)+1:int_nb(3)),:);

