% test image...


%% loading data
clear all, close all
nbpts=[.1  0 8];
pos=[1];
neg=[2:5];
seed=1;
nbkeep=20;
randn('seed',1);
rand('seed',1);
list=1:3;
%[X,Y,idx,Yval,idxval,Yte,idxte]=Get_Devis_Data_mc(nbpts,list);
[X,Y,idx,Yval,idxval,Yte,idxte]=Get_Devis_Data(nbpts,pos,neg);
%sel=1:128;
%X=X(:,:,sel);
Xsvm=GetImgSamples(X,idx);
Xsvmval=GetImgSamples(X,idxval);
Xsvmte=GetImgSamples(X,idxte);
d=4;


%% options

todo =[1 1 1] % svm, svmmoy, filter svm
f=11;
%uniquefilter=0;
d=size(X,3);
 options.f=f; % : legth of the filter
 

 %options.decy =0;%: y time shift...

  options.F=ones(f,f,d)/(f*f); %: initialisation of the filter 
  
 % options.F=zeros(f,f,d)/(f*f); %: initialisation of the filter 
 % options.F(ceil(f/2),ceil(f/2),:)=1;

 %options.F=zeros(f,f)/f; options.F(options.decy,options.decy)=1;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =1 ;%: log informatioouns
options.stopvarx=[0];% : threshold for stopping on F changes
options.stopvarj=[1e-3];
options.usegolden=1;
options.goldensearch_deltmax=.01;
options.goldensearch_stepmax=1;
options.numericalprecision=1e-3;
options.multiclass=0;

linear=0;
if linear
    options.kernel='linear';
    options.kerneloption=1;
    options.C = 1e-3; %: C value for svm
    options.regnorm2=1e-2;%[2.25e-2];
    options.regnorm12=0e-3;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
else
    options.kernel='gaussian';
    options.kerneloption=1;
    options.C = 1e4; %: C value for svm
    options.regnorm2=0e0;%[2.25e-2];
    options.regnorm12=0e2;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
end


 %options.numnoise=1
%profile on



    if todo(1)~=0 [svm,obj]=svmclass2(Xsvm,Y,options); end
    if todo(2)~=0 [svmf,obj]=svmclass2(GetFiltImgSamples(ones(f,f,size(X,3)),X,idx),Y,options); end


%[wsvm,w0svm]=lsvmclass(Xsvm,Y,.11);

 tic
 profile on
 if todo(3)~=0 [sigsvm,LOG]=filter2svmclass_idx(X,Y,idx,options); end
 profile off
 toc
 
 
 
if todo(1)~=0 ysvm=svmval2(Xsvmte,svm); precsvm=get_precision(Yte,ysvm) 
end

if todo(2)~=0 ysvm=svmval2(GetFiltImgSamples(ones(f,f,size(X,3)),X,idxte),svmf); precsvmf=get_precision(Yte,ysvm) 
end

if todo(3)~=0 ysvm=filter2svmval_idx(X,idxte,sigsvm); precfiltersvm=get_precision(Yte,ysvm) 
end

% %profile report

% svm
% 
% sel=sum(sum(sum(abs(sigsvm.F),1),2)~=0)/size(sigsvm.F,3)


%% visu AUC

figure(36)
plot(precsvm.fpr,precsvm.tpr,'k');

hold on;
plot(precsvmf.fpr,precsvmf.tpr,'b');
plot(precssvmf.fpr,precssvmf.tpr,'r');


hold off
title('AUC')
legend('Sans filtrage','Filtrage moyenneur','Filtrage optimal')
axis square



%% visu qui déchire sa race !!!
% journal proof

figure(17)
[Xres]=Getimageresult(X,LOG);
imagesc(sign(Xres))
title('moyenneur')
colormap('gray')

figure(18)
[Xres]=Getimageresult(X,sigsvm);
imagesc(sign(Xres))
title('Imagesvm')
colormap('gray')

figure(19)
[Xres]=Getimageresultsvm(X,wsvm,w0svm);
imagesc(sign(Xres))
title('svm')
colormap('gray')

figure(20)
visuimgclasses(X(:,:,1),[idx;idxte],[Y ; Yte])
title('Label')


%% visu du filtre
figure(1)
surface=1;
i=3;
j=i;
nvisu=11;
nvisu=f;
I=ifft2(fft2(sigsvm.F(:,:,i)),nvisu,nvisu);
if surface
    surf(abs(I))
else
imagesc(abs(I))
end
colorbar
figure(2)
nfft=1000;
I=fftshift(fft2(sigsvm.F(:,:,i),nfft,nfft));
imagesc(abs(I))
colorbar
%%%

%i=1;
%figure(3)
%imagesc(X(:,:,j));
%figure(4)
%imagesc(filter2(F(:,:,i),X(:,:,j)));

%figure(5)
%visuimgclasses(X(:,:,j),idx,Y)

%% visu des résultats



%%
figure(1)
nfft=100;
I=fftshift(fft2(F,nfft,nfft));
surf(abs(I))

%%
i=1;
j=1;
figure(5) ;    hold on
for i=1:f
    for j=1:f
       
plot(reshape(F(i,j,:),numel(F(i,j,:)),1),'Color',[i/f j/f 0])
    end
end


%% visu du poids des canaux
figure(11)
poids=GetCanalweightImg(sigsvm.F);
plot(poids)



%% visus qui déchirent
figure(14);plot(LOG.J); title('fonction de cout J')
figure(15);plot(LOG.nbsup); title('Evolution du nombre de vecteurs support')
%figure(13); surf(Ftot); title('Evolution du filtre')

%% visus qui déchirent en sparse
figure(14);plot(get_multi_J(LOG)); title('fonction de cout J')

%figure(13); surf(Ftot); title('Evolution du filtre')

%% évolution du poid des canaux...
res=Getcanalweight(LOG); 

figure(136); 
subplot(3,1,1)
plot(res);title('Evolution du poid des canaux')
subplot(3,1,2)
plot(LOG.wtot);title('Evolution du w')
subplot(3,1,3)
plot(LOG.wtot.*res);title('Evolution de la mult')

