% test de la fonction d'apprentissage de filtre...

%% génération données

clear all
close all
nbpts=2000;
nbptste=10*nbpts;
nbclass=2;
d=2;
nbbruit=8;
nbrel=d;

% noise of the 
sigmanoise=0;
sigmanoise2=.5

seed=1985;
rand('seed',seed);
randn('seed',seed);

sigmanoise=sigmanoise2+sigmanoise*rand(d,1);


opts.type=1;
opts.cmean=30;
opts.csigma=20;
%opts.filter=([1:floor(tfilt/2) floor(tfilt/2):-1:1 ])'/sum(([1:floor(tfilt/2) floor(tfilt/2):-1:1 ]))%ones(tfilt,1)/tfilt;
opts.params=[2*(1:nbclass)'-nbclass-1 ones(nbclass,d)*diag(sigmanoise)];
opts.param=1;
opts.dephsigs=6;
opts.d=d;
opts.w=5e-3;
opts.sigmanoisebf=3;
opts.keepswitch=1;
opts.filter=ones(1,20);%randn(1,5)%ones(1,20);
opts.filter=[cos(pi*(1:10)) ones(1,10)]/20;%randn(1,5)%ones(1,20);

% rampe: (cumsum(rand(1,20))+0.1*randn(1,20))/20
% bordel: (randn(1,20))/20; (attention au bruit hf


% taoy data generation
[x,Y,xte,Yte]=GernerSig(nbpts,nbptste,nbclass,opts);

[x,mx,vx]=gnormalise(x);
xte=(xte-ones(size(xte,1),1)*mx)./(ones(size(xte,1),1)*vx);

Y=2*Y-3;
Yte=2*Yte-3;
d=d+nbbruit;

X2=x;
X2te=xte;
X=[x randn(size(x,1),nbbruit) ];
Xte=[xte randn(size(xte,1),nbbruit) ];
Yt=Y; 


errssvm=[];
errsssvm=[];
sparsessvm=[];

%figure,plotclassestime(X,Y) 
win=2;
[xtest1 xtest2]  = meshgrid([-1:.05:1]*win,[-1:0.05:1]*win); 
nn = length(xtest1); 
xtest = [reshape(xtest1 ,nn*nn,1) reshape(xtest2 ,nn*nn,1) zeros(nn*nn,nbbruit)]; 



%% options non linear
%      svm svm0 tde_svm filtersvm
todo=[];

f=21;
options.f=f; % : legth of the filter

options.r=0;

options.decy =floor(f/2);%: y time shift...
%options.decy =0;%: y time shift...

options.F=ones(f,d)/(f); %: initialisation of the filter
%options.F=zeros(f,d)/(f); %: initialisation of the filter
%options.F(options.decy+1,:)=1;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =50 ;%: log informatioouns
options.stopvarx=[0];% : threshold for stopping on F changes
options.stopvarj=[1e-4];
options.goldensearch_deltmax=.01;
options.goldensearch_stepmax=1;
options.numericalprecision=1e-6;
options.multiclass=0;
options.linesearch=1;
options.ls_tol=1e-3;

options.method=0;

    options.kernel='linear';
    krel=1e0;
    options.kerneloption=1;
    options.lambda= 1e2*krel; 
    options.regnorm2=1e2*krel;%[2.25e-2];
    options.regnorm12=0e2*krel;%[2.25e-2];
    options.solver=4;
    options.use_cg=3;


% Time Delay ERmbedding
%[svm_tde,obj]=svmclass2(time_delay_embedding(X,options),Y,options)

% Time Delay ERmbedding
%[svm_tdeas,obj]=adaptivescaling_svmclass2(time_delay_embedding(X,options),Y,options)

tic
profile on
[filterreg,LOG]=lfilterregression(X,Y,options);
profile off
toc

%profile report


% time delay embedding
%[ypred,yval]=svmval2(time_delay_embedding(Xte,options),svm_tde);
%prec_tde=get_precision(Yte,ypred)

% time delay embedding
%[ypred,yval]=svmval2(time_delay_embedding(Xte,options),svm_tdeas);
%prec_tdeas=get_precision(Yte,ypred)

% optimal
[ypred]=lfilterregressionval(X,filterreg);
mse_filter=mean((ypred-Y).^2)
[ypred]=lfilterregressionval(Xte,filterreg);
mse_filtertest=mean((ypred-Yte).^2)
corr_filtertest=corr(ypred,Yte)


%%%
figure(15)
plot(ypred(1:1000), 'DisplayName', 'ypred', 'YDataSource', 'ypred'); hold all; plot(Yte(1:1000), 'DisplayName', 'Yte', 'YDataSource', 'Yte'); hold off; figure(gcf)

ylim([-1.5 1.5])


figure(16+options.method)

list={'FilterReg','WinReg','GroupWinReg'};


plot(filterreg.F.*(repmat(filterreg.w',f,1)), 'DisplayName', 'filterreg.F', 'YDataSource', 'filterreg.F'); figure(gcf)
title(list{options.method+1})







