% test de la fonction d'apprentissage de filtre...

%% génération données

clear all
close all
nbpts=10000;
nbptste=10*nbpts;
nbclass=2;
d=2;
nbbruit=8;
nbrel=d;

% noise of the 
sigmanoise=0;
sigmanoise2=1

seed=1985;
rand('seed',seed);
randn('seed',seed);

sigmanoise=sigmanoise2+sigmanoise*rand(d,1);


opts.type=1;
opts.cmean=30;
opts.csigma=10;
%opts.filter=([1:floor(tfilt/2) floor(tfilt/2):-1:1 ])'/sum(([1:floor(tfilt/2) floor(tfilt/2):-1:1 ]))%ones(tfilt,1)/tfilt;
opts.params=[2*(1:nbclass)'-nbclass-1 ones(nbclass,d)*diag(sigmanoise)];
opts.param=1;
opts.dephsigs=6;
opts.d=d;
opts.w=5e-3;
opts.sigmanoisebf=3;
opts.keepswitch=1;
opts.filter=ones(1,20);%randn(1,5)%ones(1,20);
opts.filter=[cos(pi*(1:10)) ones(1,10)]/20;%randn(1,5)%ones(1,20);

% rampe: (cumsum(rand(1,20))+0.1*randn(1,20))/20
% bordel: (randn(1,20))/20; (attention au bruit hf


% taoy data generation
[x,Y,xte,Yte]=GernerSig(nbpts,nbptste,nbclass,opts);

[x,mx,vx]=gnormalise(x);
xte=(xte-ones(size(xte,1),1)*mx)./(ones(size(xte,1),1)*vx);

Y=2*Y-3;
Yte=2*Yte-3;
d=d+nbbruit;

X2=x;
X2te=xte;
X=[x randn(size(x,1),nbbruit) ];
Xte=[xte randn(size(xte,1),nbbruit) ];
Yt=Y; 


errssvm=[];
errsssvm=[];
sparsessvm=[];

%figure,plotclassestime(X,Y) 
win=2;1
[xtest1 xtest2]  = meshgrid([-1:.05:1]*win,[-1:0.05:1]*win); 
nn = length(xtest1); 
xtest = [reshape(xtest1 ,nn*nn,1) reshape(xtest2 ,nn*nn,1) zeros(nn*nn,nbbruit)]; 

%% visu du toy

subplot(3,3,[3 6])
plotclasses(X,Y)
xlim([-2.5 2.5])
ylim([-2.5 2.5])
title('Sample projection on channels')
xlabel('Channel 1')
ylabel('Channel 2')
subplot(3,3,[1 2 4 5])
%plot(X);ylim([-2.5 2.5])
ploteegsignal(X); set(gca,'Ytick',[])
set(gca,'xtick',[])
title('Toy signal along time')
legend('Channel 1','Channel 2')
subplot(3,3,[7 8])
plot(Y*0.5+1.5)
title('Toy signal labels along time')
ylim([.5 2.5])
    



%% options non linear
%      svm svm0 tde_svm filtersvm
todo=[];

f=11;
options.f=f; % : legth of the filter

options.r=0;

options.decy =floor(f/2);%: y time shift...
%options.decy =0;%: y time shift...

options.F=ones(f,d)/(f); %: initialisation of the filter
%options.F=zeros(f,d)/(f); %: initialisation of the filter
%options.F(options.decy+1,:)=1;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =40 ;%: log informatioouns
options.stopvarx=[0];% : threshold for stopping on F changes
options.stopvarj=[1e-4];
options.goldensearch_deltmax=.01;
options.goldensearch_stepmax=1;
options.numericalprecision=1e-3;
options.multiclass=0;
options.linesearch=0;
options.ls_tol=1e-3;




linear=0;
if linear
    options.kernel='linear';
    options.kerneloption=1;
    options.C = 1e3; %: C value for svm
    options.regnorm2=1e4;%[2.25e-2];
    options.regnorm12=0e-3;%[2.25e-2];
    options.regnormdiff=0e4;
    options.solver=4;
    options.use_cg=1;
else
    options.kernel='gaussian';
    options.kerneloption=1;
    options.C = 1e4; %: C value for svm
    options.regnorm2=1e3;%[2.25e-2];
    options.regnormdiff=0e3;
    options.regnorm12=0e2;%[2.25e-2];
    options.solver=4;
    options.use_cg=1;
end


options.sel=rand(nbpts,1)<0.1;
options.selsparse=1;

Xsel=X(options.sel,:);
Ysel=Y(options.sel);
% sans filtrage
[svm,obj]=svmclass2(Xsel,Ysel,options)

% avec filtrage
[svmf,obj]=svmclass2(GetFiltTimeSamples(options.F,X,options.sel),Ysel,options)

% Time Delay ERmbedding
%[svm_tde,obj]=svmclass2(time_delay_embedding(X,options),Y,options)

% Time Delay ERmbedding
%[svm_tdeas,obj]=adaptivescaling_svmclass2(time_delay_embedding(X,options),Y,options)

tic
profile on
[sigsvm,LOG]=filtersvmclass(X,Y,options);
profile off
toc

%profile report


% svm
ysvm=svmval2(Xte,svm);
precsvm=get_precision(Yte,ysvm)

% moyenneur
%[ypred,yval]=filtersvmval(Xte,LOG);
[ypred,yval]=svmval2(mfilter(options,Xte),svmf);
prec0=get_precision(Yte,ypred)

% time delay embedding
%[ypred,yval]=svmval2(time_delay_embedding(Xte,options),svm_tde);
%prec_tde=get_precision(Yte,ypred)

% time delay embedding
%[ypred,yval]=svmval2(time_delay_embedding(Xte,options),svm_tdeas);
%prec_tdeas=get_precision(Yte,ypred)

% optimal
[ypred,yval]=filtersvmval(Xte,sigsvm);
prec=get_precision(Yte,ypred)


%% GMKL...


options.C = 3e1;
options.kerneltype=1;% 0:sum 1:prod
options.regtype=0; % 0:l1 1:l2
options.kerneloption=1;
options.verbose=1;


tic 
[gmkl,obj]=gmklclass(time_delay_embedding(X,optionstdeas),Y,optionstdeas)
toc

[ypred] = gmklval(time_delay_embedding(Xte,options),gmkl);
precgmkl=get_precision(Yte,ypred)


%% Time Delay Embedding GMKL

figure(11)

subplot(1,2,1)
plot(sigsvm.F);
title('Filtersvm')
subplot(1,2,2)
plot(reshape(gmkl.d',f,d)');
title('TDE')


%% Gaussian mixtures...

optionsgmm.nbgauss=[2];
optionsgmm.nbiterem=50;
optionsgmm.nbiterkmeans=20;
optionsgmm.verbose=0;

% gazussian mixture
tic 
[gmm,obj]=gmmclass(X,Y,optionsgmm)
toc


[ypred,ydec] = gmmval(Xte,gmm);
prec_gmm=get_precision(Yte,ypred)

% gaussian mixture with filtering

tic 
[gmmfilter,obj]=gmmclass(mfilter(sigsvm,X),Y,optionsgmm)
toc


[ypred,ydec] = gmmval(mfilter(sigsvm,Xte),gmm);
prec_gmmfilter=get_precision(Yte,ypred)


%% Time Delay Embedding

figure(11)

subplot(1,2,1)
plot(sigsvm.F);
title('Filtersvm')
subplot(1,2,2)
plot(reshape(svm_tdeas.gamma',f,d)');
title('TDE')

%% visu filtre
figure(12)
nbpoints=201;
subplot(2,1,1)
plot(sigsvm.F(:,:))
title('Filtre optimal')

subplot(2,1,2)
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(sigmanoise*randn(1,length(Y))/length(Y),nbpoints))),'Color',[.5 .5 .5]);



hold on
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(Y'/length(Y),nbpoints))),'m');
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(sigsvm.F(:,:)/options.f,nbpoints))));
hold off
legend('FFt Y','F(:,1)')
title('FFt filtre optimal (fréquences normalisées)')

%% visu fft 2
figure(112)

nbpoints=200;

%abs(fftshift(fft(sigmanoise(1)*randn(length(Y),1)/length(Y),nbpoints)))
k=0.05

subplot(2,1,1)

plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(Y'/length(Y),nbpoints))),'m');
hold on
plot(linspace(-1/2,1/2,nbpoints),sigmanoise(1)*ones(1,nbpoints)/nbpoints,'Color',[.5 .5 .5]);
title('Fourier transform of the label sequence Y')
legend('|fft(Y)|','noise level')
hold off

subplot(2,1,2)

plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(sigsvm.F(:,:)/options.f,nbpoints))));

%legend('|fft(Y)|','|fft(F(:,1))|','|fft(F(:,2))|','noise level')
title('Fourier transform for the optimal filters')
legend('|fft(F(:,1))|','|fft(F(:,2))|')

%% visu convolution...
figure(13)
nbpoints=1000;
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(sigsvm.F(:,1)/norm(sigsvm.F(:,1)),nbpoints))));

hold on
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(opts.filter/norm(opts.filter),nbpoints))),'r');
%plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(opts.filter/norm(opts.filter),nbpoints).*fft(sigsvm.F(:,1)'/norm(sigsvm.F(:,1)),nbpoints))),'g');
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(Y'/norm(Y),nbpoints))),'m');
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(opts.filter/norm(opts.filter),nbpoints).*fft(Y'/norm(Y),nbpoints))),'c');

hold off
legend('Optimal Filter','Convolutionnal noise','Y','Y*noise')%,'Filter*noise'
title('abs(FFt) des filtres') 



%% test viterbi

prior=GetMarkovPrior(Y);
transmat=GetMarkovTransitionMatrix((Y+1)/2+1);


% SVM
 svm=svmtoproba(X,Y,svm);
 yprob=psvmval2(Xte,svm);

path = viterbi_path(prior, transmat, [yprob 1-yprob]');
%path = viterbi_path(prior, transmat, [yprob ]');
ymm=(2*path-3)';
precmm=sum(ymm~=Yte)/length(Yte)

% SVM + filtering
svmf=svmtoproba(mfilter(options,X),Y,svmf);
yprob=psvmval2(mfilter(options,Xte),svmf);

path = viterbi_path(prior, transmat, [yprob 1-yprob]');
ymm=(2*path-3)';
precmmf=sum(ymm~=Yte)/length(Yte)

% FilterSVM
sigsvm=svmtoproba(mfilter(sigsvm,X),Y,sigsvm);
yprob=psvmval2(mfilter(sigsvm,Xte),sigsvm);
path = viterbi_path(prior, transmat, [yprob 1-yprob]');
ymm=(2*path-3)';
precmmfiltersvm=sum(ymm~=Yte)/length(Yte)

% HMM
yprob=pgmmval(Xte,gmm);
path = viterbi_path(prior, transmat, [yprob]');
ymm=(2*path-3)';
precmm_gmm=sum(ymm==Yte)/length(Yte)

% HMM Filter
yprob=pgmmval(mfilter(sigsvm,Xte),gmmfilter);
path = viterbi_path(prior, transmat, [yprob]');
ymm=(2*path-3)';
precmm_gmmfilter=sum(ymm==Yte)/length(Yte)

%% visu AUC

figure(36)
plot(precsvm.fpr,precsvm.tpr,'k');

hold on;
plot(prec0.fpr,prec0.tpr,'b');
plot(prec.fpr,prec.tpr,'r');
plot(prec_gmm.fpr,prec_gmm.tpr,'c');
plot(prec_gmmfilter.fpr,prec_gmmfilter.tpr,'g');

hold off
title('AUC')
legend('SVM','AVG-SVM','FilterSVM','GMM','FilterGMM')
axis square

%% visu marrante


figure(1),plotclassestime(Xte,Yte),title('X,Y')
figure(2),plotclassestime(mfilter(sigsvm,Xte),Yte),title('X filtré,Y')

%% visu poster jeunes

figure(112)

nbkeep=200;
Xt=X(1:nbkeep,:);
Yt=Y(1:nbkeep);

plotclasses2(Xt,Yt)

%% visus qui déchirent
figure(14);plot(LOG.J); title('fonction de cout J')
%figure(15);plot(LOG.nbsup); title('Evolution du nombre de vecteurs support')
%figure(13); surf(Ftot); title('Evolution du filtre')


%plot(Getwweight2(LOG));title('Evolution du w')


%% visu du filtre tout court
figure(16)
plot(sigsvm.F)

%% visu surf
figure(16)
surf(sigsvm.F)


%% viu poids des cnausx
figure(16)
%subplot(2,1,1)
plot(sum(abs(sigsvm.F)),'-o')
%subplot(2,1,2)
%plot(abs(w),'-o')

%%
figure(10)
subplot(1,2,1)

az=-16.5;
el=40;
nbins=20;


[test,C]=hist3(Xte(Yte==1,:),[nbins nbins]);
surf(C{1},C{2},test)
%zlim([0,150])
%set(gcf,'renderer','opengl');
set(get(gca,'child'),'FaceColor','interp','CDataMode',...
'auto');
view(az,el)
xlabel('Ch 1')
ylabel('Ch 2')
xlim([-3.5 3.5])
ylim([-3.5 3.5])
%zlim([0 1600])
set(gca,'FontSize',12) 

title('Bivariate histogram for class 1')
subplot(1,2,2)

[test,C]=hist3(Xte(Yte==-1,:),[nbins nbins]);
surf(C{1},C{2},test)
%zlim([0,150])
set(get(gca,'child'),'FaceColor','interp','CDataMode',...
'auto');
title('Bivariate histogram for class 2')
%zlim([0
view(az,el)
xlabel('Ch 1')
ylabel('Ch 2')
xlim([-3.5 3.5])
ylim([-3.5 3.5])
set(gca,'FontSize',12) 
%%

figure(10)
subplot(1,2,1)

az=-22.5;
el=40;
nbins=20;

temp=mfilter(sigsvm,Xte);
[test,C]=hist3(temp(Yte==1,:),[nbins nbins]);
surf(C{1},C{2},test)
%zlim([0,150])
%set(gcf,'renderer','opengl');
set(get(gca,'child'),'FaceColor','interp','CDataMode',...
'auto');view(az,el)
xlabel('Ch 1')
ylabel('Ch 2')
xlim([-3.5 3.5])
ylim([-3.5 3.5])
title('Bivariate histogram for filtered class 1')
subplot(1,2,2)
set(gca,'FontSize',12) 

[test,C]=hist3(temp(Yte==-1,:),[nbins nbins])
surf(C{1},C{2},test)
%zlim([0,150])
set(get(gca,'child'),'FaceColor','interp','CDataMode',...
'auto');view(az,el)
xlabel('Ch 1')
ylabel('Ch 2')
xlim([-3.5 3.5])
ylim([-3.5 3.5])
title('Bivariate histogram for filtered  class 2')
set(gca,'FontSize',12) 



%% visu points

figure(1); 
clf; 
subplot(2,2,1)
ypredfond=svmval2(xtest,svm);
ypredfond = reshape(ypredfond,nn,nn); 
contourf(xtest1,xtest2,ypredfond);hold on
h1=plot(X(Y==1,1),X(Y==1,2),'+r'); 
h2=plot(X(Y==-1,1),X(Y==-1,2),'+b');
title('Decision function for svm without filtering')
h3=plot(svm.xsup(:,1),svm.xsup(:,2),'og'); 
colormap('gray')
hold off

subplot(2,2,2)
Xtemp=mfilter(options,X);
ypredfond=svmval2(xtest,svmf);
ypredfond = reshape(ypredfond,nn,nn); 
contourf(xtest1,xtest2,ypredfond);hold on
h1=plot(Xtemp(Y==1,1),Xtemp(Y==1,2),'+r'); 
h2=plot(Xtemp(Y==-1,1),Xtemp(Y==-1,2),'+b'); 
title('Decision function for svm with Avg filtering')
h3=plot(svmf.xsup(:,1),svmf.xsup(:,2),'og'); 
hold off

subplot(2,2,3)
Xtemp=mfilter(sigsvm,X);
ypredfond=svmval2(xtest,sigsvm);
ypredfond = reshape(ypredfond,nn,nn); 
contourf(xtest1,xtest2,ypredfond);hold on
h1=plot(Xtemp(Y==1,1),Xtemp(Y==1,2),'+r'); 
h2=plot(Xtemp(Y==-1,1),Xtemp(Y==-1,2),'+b'); 
title('Decision function for svm with optimal filtering')
h3=plot(sigsvm.xsup(:,1),sigsvm.xsup(:,2),'og');
hold off

subplot(2,2,4)
contour(xtest1,xtest2,ypredfond);hold on
%h1=plot(Xtemp(Y==1,1),Xtemp(Y==1,2),'+r'); 
%h2=plot(Xtemp(Y==-1,1),Xtemp(Y==-1,2),'+b'); 
title('Final support vector displacement')
%

%h1=quiver(X(Y==1,1),X(Y==1,2),Xtemp(Y==1,1)-X(Y==1,1),Xtemp(Y==1,2)-X(Y==1,2),1,'r'); 
%h1=quiver(X(Y==-1,1),X(Y==-1,2),Xtemp(Y==-1,1)-X(Y==-1,1),Xtemp(Y==-1,2)-X(Y==-1,2),1,'b'); 

h1=quiver(X(sigsvm.pos,1),X(sigsvm.pos,2),Xtemp(sigsvm.pos,1)-X(sigsvm.pos,1),Xtemp(sigsvm.pos,2)-X(sigsvm.pos,2),0,'g'); 

%h1=plot(X(Y==1,1),X(Y==1,2),'+r'); 
%h2=plot(X(Y==-1,1),X(Y==-1,2),'+b');

h1=plot(Xtemp(sigsvm.pos,1),Xtemp(sigsvm.pos,2),'+r'); 
%h2=plot(Xtemp(sigsvm.pos,1),Xtemp(sigsvm.pos,2),'+b');


h3=plot(Xtemp(sigsvm.pos,1),Xtemp(sigsvm.pos,2),'og');

%quiver(Xtemp(sigsvm.pos,1),Xtemp(sigsvm.pos,2),-(Xtemp(sigsvm.pos,1)-X(sigsvm.pos,1)),-(Xtemp(sigsvm.pos,2)-X(sigsvm.pos,2)))
%quiver(0,0,1,1)
hold off


%% générer images


figure(1); 
clf; 
Xtemp=mfilter(options,X);
ypredfond=svmval2(xtest,sigsvm);
ypredfond = reshape(ypredfond,nn,nn); 
contour(xtest1,xtest2,ypredfond);hold on
h1=plot(Xtemp(Y==1,1),Xtemp(Y==1,2),'+r'); 
h2=plot(Xtemp(Y==-1,1),Xtemp(Y==-1,2),'+b'); 
title('support vectors evolution')
%h3=plot(svmf.xsup(:,1),svmf.xsup(:,2),'og'); 
hold off
colormap('gray')
print(['imgs/image' num2str(1) '.png'],'-dpng')
film=getframe;
for j = 2:length(LOG.Ftot)
    
    figure(1)
    clf
 Xtemp=mfilter(LOG.Ftot{j},X,options.decy);
ypredfond=svmval2(xtest,sigsvm);
ypredfond = reshape(ypredfond,nn,nn); 
contour(xtest1,xtest2,ypredfond);hold on
h1=plot(Xtemp(Y==1,1),Xtemp(Y==1,2),'+r'); 
h2=plot(Xtemp(Y==-1,1),Xtemp(Y==-1,2),'+b'); 
title('support vectors evolution')
    colormap('gray')
    hold off
    print(['imgs/image' num2str(j) '.png'],'-dpng')
    
    
 film(j) = getframe;
end
movie(film,1,1)
movie2avi(film,'film','fps',2)