function [ypredval,ypred]=filter2svmval_idx(X,idxs,sigsvm)
% function returning  the labeling of a signal for a given signal svm
% decision function


if ~isfield(sigsvm,'multiclass'); sigsvm.multiclass=0; end


if sigsvm.multiclass==0
    
if nargin<4
    F=sigsvm.F;
end

Xt=GetFiltImgSamples(F,X,idxs);

if isempty(sigsvm.xsup) %&& strcmp(sigsvm.kernel,'linear')
    ypredval=lsvmval(Xt,sigsvm.w,sigsvm.w0);
else
    ypredval=svmval(Xt,sigsvm.xsup,sigsvm.w,sigsvm.w0,sigsvm.kernel,sigsvm.kerneloption,1);
end


ypred=sign(ypredval);

else
    
      
    ypredval=zeros(length(idxs),sigsvm.nbclass);
    switch sigsvm.multiclass

        case 1 % one against all


            for i=1:sigsvm.nbclass
                
                [ypredval(:,i)]=filter2svmval_idx(X,idxs,sigsvm.models{i});
                

            end
            
            [temp,ypred]=max(ypredval,[],2);

    end
    
end