function DF=gradC_gaussian(X,alphay,C,options)
% gradient of C for dr_svm for the gaussian kernel!

Xt=X*C;


    pos=find(alphay);

    Xt=Xt(pos,:);
    alphay=alphay(pos,:);

    %
    K=svmkernel(Xt,options.kernel,options.kerneloption);

    f=size(C,1);
    d=size(C,2);

    DF=zeros(f,d);
    
    for j=1:d
        Mx=repmat(Xt(:,j),1,size(Xt,1));
        %MXto=MXtp';
        Mx=Mx-Mx';
        for i=1:f

       
            Xp=X(pos,i);
           % Xp=Xp(pos);

            MXp=repmat(Xp,1,length(Xp));
            %MXo=repmat(Xp',length(Xp),1);
           % MXo= MXp';

            M=K.*(MXp-MXp').*(Mx);

            DF(i,j)=.5/options.kerneloption^2*alphay(:)'*(M*alphay(:));
        end
    end