function DF=gradF_gaussiansel(X,alphay,F,options)
% gradient of F for filtersvm for the gaussian kernel!


if options.selsparse~=0
    %Xt=mfilter(F,X);
    Xt=GetFiltTimeSamples(F,X,options.sel);
else
    Xt=mfilter(F,X);
    Xt=Xt(logical(options.sel),:);
end

pos=find(alphay);

Xt=Xt(pos,:);


alphay=alphay(pos,:);

%
K=svmkernel(Xt,options.kernel,options.kerneloption);

f=size(F,1);
d=size(F,2);

DF=zeros(f,d);
for j=1:d
    Mx=repmat(Xt(:,j),1,size(Xt,1));
    %MXto=MXtp';
    Mx=Mx-Mx';
    for i=1:f

        %
        %             Xp=DecalageSignal(X(:,j),(i-1));
        %
        %             Xp=Xp(pos);

        if options.selsparse~=0
            Xp=GetDecTimeSamples(X(:,j),(i-1),options.sel);
        else
            Xp=DecalageSignalcycl(X(:,j),(i-1));
            Xp=Xp(logical(options.sel),:);
        end
        Xp=Xp(pos);

        MXp=repmat(Xp,1,length(Xp));
        %MXo=repmat(Xp',length(Xp),1);
        % MXo= MXp';

        M=K.*(MXp-MXp').*(Mx);

        DF(i,j)=0.5/options.kerneloption^2*alphay(:)'*(M*alphay(:));
    end
end