function D=grad_gamma_gaussian(X,alphay,gamma,options)
% gradient of F for filtersvm for the gaussian kernel!

    pos=find(alphay);

    Xt=X(pos,:);
    alphay=alphay(pos,:);
    
    %
    K=svmkernel(Xt,options.kernel,options.kerneloption);
    
    
    d=size(X,2);
    
    D=zeros(1,d);
    
    for j=1:d
        Mx=repmat(Xt(:,j),1,size(Xt,1));
        %MXto=MXtp';
        Mx=(Mx-Mx').^2;
        
        %MXo=repmat(Xp',length(Xp),1);
        % MXo= MXp';
        
        M=K.*(Mx);
        
        D(1,j)=0.5/options.kerneloption^2*gamma(j)*alphay(:)'*(M*alphay(:));
    end
    
end