function M=GetMarkovTransitionMatrix(Y)

vals=sort(unique(Y));

nbclass=length(vals);

M=zeros(nbclass,nbclass);

for i=1:length(Y)-1
    v1=Y(i);
    v2=Y(i+1);
    M(v1,v2)=M(v1,v2)+1; 
end

for i=1:nbclass
    nbyclass(i)=sum(Y==vals(i));
    M(i,:)=M(i,:)./nbyclass(i);
end