function svm=gmkltoproba(Xval,Yval,svm)
% function returning an updated structure with A and B platt

if ~isfield(svm,'multiclass'); svm.multiclass=0; end

if svm.multiclass==0
    
ypred=gmklval(Xval,svm);

prior0=sum(Yval==-1);
prior1=sum(Yval==1);

[A,B]=platt([ypred ],Yval,prior0,prior1);

svm.A=A;
svm.B=B;

else
     vals=sort(unique(Yval),'ascend');
    
    for i=1:svm.nbclass
        svm.models{i}=  gmkltoproba(Xval,((Yval==vals(i))-(Yval~=vals(i))),svm.models{i});         
    end
    
    
    
    
end