function y=pgmklval(X,svm)

if ~isfield(svm,'multiclass'); svm.multiclass=0; end

if svm.multiclass==0
    
     y=gmklval(X,svm);
    y=1./(1+exp(svm.A*y+svm.B));

else
    
     y=zeros(size(X,1),svm.nbclass);

    switch svm.multiclass

        case 1 % one against all


            for i=1:svm.nbclass
                
                y(:,i)=gmklval(X,svm.models{i});

                y(:,i)=1./(1+exp(svm.models{i}.A*y(:,i)+svm.models{i}.B)); 

            end
            
            y=y./repmat(sum(y,2),1,   svm.nbclass);         


    end

    
    
end