function [Xn,mx,vx]=gnormalise(X,centeronly)
% function which retruns a normalised list of vectors

if nargin==1
    centeronly=0;
end;

mx=mean(X);
vx=std(X);
vx=vx+(vx==0);
Mx=ones(size(X,1),1)*mx;
Vx=ones(size(X,1),1)*vx;
if centeronly==0
    Xn=(X-Mx)./(Vx);
else
    Xn=(X-Mx);
end;