function plotclasses(X,k)
% plots a 2D graph with différent classes

style='+o*xsd<>ph';
%color= 'rgbcmyk';
%
color=  [0,0,1;
    1,0,0;
    0,.7,0;
    0,.7,.7;
    1,0,1;
    .7,.7,0;
    0,0,0];




if min(k)>=0

    sm=round(max(k));

   % clf

    hold on,

    for i=1:sm
        idx=find(k==i);
        Xtemp=X(idx,:);

        plot(Xtemp(:,1),Xtemp(:,2),[' ' style(i) ],'MarkerEdgeColor',color(i,:));

    end



    hold off

else
    hold on

    sm=2;
    ic=[1 -1];

    for i=1:sm
        idx=find(k==ic(i));
        Xtemp=X(idx,:);

        plot(Xtemp(:,1),Xtemp(:,2),[' ' style(i) ],'MarkerEdgeColor',color(i,:));

    end

    hold off


end

