% test de l'appel à la fonctiojn test...


%% initialisation

clear all

% validation parameters
opt.nbloop=10;
opt.nbrel=2;
opt.nbtot=10;
d=opt.nbtot;
opt.nbpts=[1000 1000 10000];

opt.noise=1;
opt.noiserand=0;


f=21;

opt.type=4;
opt.f=f;
opt.dephsigs=10;
opt.decy=11;
opt.nbitermax=20;
opt.KD=5;

% params to validate

opt.cvalues=logspace(3,6,3);
opt.sigmavalues=linspace(5,100,3);
opt.filtercvalues=logspace(3,6,3);
opt.regnorm2=logspace(0,2,3);
opt.regnorm12=logspace(1,3,3);


opt.seed=1;

opt.todo=[1 1 1 0];



% classification parameters
options.f=f; % : legth of the filter

%options.decy =floor(f/2);%: y time shift...
%options.decy =11;%: y time shift...
options.decy =0;%: y time shift...

options.F=ones(f,d)/(f); %: initialisation of the filter
%options.F=zeros(f,d)/(f); %: initialisation of the filter
%options.F(options.decy,:)=1;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =10 ;%: log informatioouns
options.stopvarx=[0];% : threshold for stopping on F changes
options.stopvarj=[1e-3];
options.usegolden=1;
options.goldensearch_deltmax=.01;
options.goldensearch_stepmax=1;
options.numericalprecision=1e-3;

linear=0;
if linear
    options.kernel='linear';
    options.kerneloption=1;
    options.C = 1e-3; %: C value for svm
    options.regnorm2=1e-2;%[2.25e-2];
    options.regnorm12=0e-3;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
else
    options.kernel='gaussian';
    options.kerneloption=1;
    options.C = 1e3; %: C value for svm
    options.regnorm2=1e2;%[2.25e-2];
    options.regnorm12=0e2;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
end 
                      
opt.options=options;

opt.sub=1;

filename=  GetBCIFilename(opt);

%         svm svmfilt wsvm ssvml2 hmm

%listf=[1 2 4 10]
listf=[21]

%%

for l=1:length(listf)

    opt.f=listf(l);
    opt.options.f=listf(l);
    opt.options.F=ones(listf(l),d)/(listf(l));
    
    
    for i=1:3
    opt.sub=i;
    
    GetBCIFilename(opt)
    CalcBCIResults(opt)

    end


end


%%

keyboard

%% getresults

opt.sub=1;
getres.filename=@GetBCIFilename;
getres.opt=opt;
getres.var=listf;
getres.varname='f';
getres.getvars={'err_filter'};

res=GetMultiresults(getres)


%%


opt.sub=1;
getres.filename=@GetBCIFilename;
getres.opt=opt;
getres.var=listf;
getres.varname='f';
getres.getvars={'err_filter','err_filter_mm'};

precs=[];
precs_mm=[];
for i=1:3
    opt.sub=i;
    getres.opt=opt;
    res=GetMultiresults(getres)
    precs=[precs res.err_filter'];
    precs_mm=[precs_mm res.err_filter_mm'];
end

precs