
clear all
                      

%% loading


subject=1;
addpath('..')

%taille=[1000 100];
%[X,Y,Xte,Yte]=GetDataBCI_III(subject,num,taille);
%[X,Y,Xte,Yte]=GetDataBCI_III2(subject);
[X,Y,Xte,Yte,Xval,Yval]=GetDataBCI_IIIVal2(subject);

%X=X(1:taille(1),:);
%Y=Y(1:taille(1),:);

%X=[X;Xval];
%Y=[Y;Yval];

%Xte=Xval;
%Yte=Yval;

[Xtemp,mx,vx]=gnormalise([X; Xval]);
clear Xtemp
Mx=ones(size(X,1),1)*mx;
Vx=ones(size(X,1),1)*vx;
X=(X-Mx)./Vx;

Mx=ones(size(Xte,1),1)*mx;
Vx=ones(size(Xte,1),1)*vx;
Xte=(Xte-Mx)./Vx;

Mx=ones(size(Xval,1),1)*mx;
Vx=ones(size(Xval,1),1)*vx;
Xval=(Xval-Mx)./Vx;

% downsampling...
KD=5;
X=avgdownsampling(X,KD);
Xte=avgdownsampling(Xte,KD);
Xval=avgdownsampling(Xval,KD);
Y=downsample(Y,KD,ceil(KD/2));
Yte=downsample(Yte,KD,ceil(KD/2));
Yval=downsample(Yval,KD,ceil(KD/2));


%% params


d=size(X,2);
nbpts=size(X,1);
%Y=Yd(:,1);
%Yte=Ydte(:,1);

f=10;
options.f=f; % : legth of the filter

options.decy =0;%: y time shift...
%options.decy =0;%: y time shift...

options.F=ones(f,d)/(f); %: initialisation of the filter
%options.F=zeros(f,d)/(f); %: initialisation of the filter
%options.F(options.decy,:)=1;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =20 ;%: log informatioouns
options.stopvarx=[0];% : threshold for stopping on F changes

options.stopvarj=[1e-3];
options.usegolden=1;
options.goldensearch_deltmax=.01;
options.goldensearch_stepmax=1;
options.numericalprecision=1e-3;
options.multiclass=1;

linear=1;
if linear
    options.kernel='linear';
    options.kerneloption=1;
    options.C = 1e0; %: C value for svm
    options.regnorm2=1e0;%[2.25e-2];
    options.regnorm12=0e-3;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
else
    options.kernel='gaussian';
    options.kerneloption=10;
    options.C = 1e3; %: C value for svm
    options.regnorm2=1e1;%[2.25e-2];
    options.regnorm12=0e2;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
end


% sans filtrage
tic
[svm,obj]=svmclass2(X,Y,options)
toc

% avec filtrage
tic
[svmf,obj]=svmclass2(mfilter(options,X),Y,options)
toc

tic
profile on
[sigsvm,LOG]=filtersvmclass(X,Y,options);
profile off
toc

%profile report


% svm
ysvm=svmval2(Xte,svm);
precsvm=get_precision(Yte,ysvm)

% moyenneur
%[ypred,yval]=filtersvmval(Xte,LOG);
[ypred]=svmval2(mfilter(options,Xte),svmf);
prec0=get_precision(Yte,ypred)

% optimal
[ypred,yval]=filtersvmval(Xte,sigsvm);
prec=get_precision(Yte,ypred)


%% linear group

options.C = 1e4;


d=size(X,2);
nbpts=size(X,1);
%Y=Yd(:,1);
%Yte=Ydte(:,1);

f=50;
options.f=f; % : legth of the filter

options.decy =0;%: y time shift...
%options.decy =0;%: y time shift...

options.W0=ones(f*d+1,1)/(f); %: initialisation of the filter

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =100 ;%: log informatioouns
options.stopvarx=[0e0];% : threshold for stopping on F changes
options.stopvarj=[1e-8];
options.usegolden=1;
options.goldensearch_deltmax=.01;
options.goldensearch_stepmax=1;
options.numericalprecision=1e-3;

groups=floor(1:1/f:d+1);
groups=groups(1:end-1)

options.groups=groups%ones(10,1)%ones(10,1)%1:10
options.nu=2;
options.L0=1;

tic 
[svm_tde,obj,LOG]=lgroupsvmclass(time_delay_embedding(X,options),Y,options)
toc

[ypred] = svmval2(time_delay_embedding(Xte,options),svm_tde);
prectde=get_precision(Yte,ypred)

%% test viterbi

prior=GetMarkovPrior(Y);
transmat=GetMarkovTransitionMatrix(Y);


% SVM
 svm=svmtoproba(X,Y,svm);
 yprob=psvmval2(Xte,svm);

%path = viterbi_path(prior, transmat, [yprob 1-yprob]');
path = viterbi_path(prior, transmat, [yprob ]');
ymm=(path)';
precmm=sum(ymm~=Yte)/length(Yte)

% SVM + filtering
svmf=svmtoproba(mfilter(options,X),Y,svmf);
yprob=psvmval2(mfilter(options,Xte),svmf);


%path = viterbi_path(prior, transmat, [yprob 1-yprob]');
path = viterbi_path(prior, transmat, [yprob ]');
ymm=(path)';
precmmf=sum(ymm~=Yte)/length(Yte)

% FilterSVM
sigsvm=filtersvmtoproba(X,Y,sigsvm);
yprob=pfiltersvmval(Xte,sigsvm);
%path = viterbi_path(prior, transmat, [yprob 1-yprob]');
path = viterbi_path(prior, transmat, [yprob ]');
ymm=(path)';
precmmfiltersvm=sum(ymm~=Yte)/length(Yte)




