% visu BCI dataset...


%% initialisation

clear all
addpath('..')
% validation parameters
opt.nbloop=10;
opt.nbrel=2;
opt.nbtot=10;
d=opt.nbtot;
opt.nbpts=[1000 1000 10000];

opt.noise=1;
opt.noiserand=0;


f=50;

opt.type=4;
opt.f=f;
opt.dephsigs=10;
opt.decy=0;
opt.nbitermax=20;
opt.KD=5;

opt.linear=1

% params to validate

opt.cvalues=logspace(3,6,3);
opt.sigmavalues=linspace(5,100,3);8
opt.filtercvalues=logspace(3,6,3);
opt.regnorm2=logspace(0,2,3);
opt.regnorm12=logspace(1,3,3);


opt.seed=1;

opt.todo=[0 0 1 0];

opt.sub=1;

filename=  GetBCIFilename(opt);

load(filename)

load ch


%% extraction données
lag=0;
class=2;

res=filter2ch(filtersvm.models{class}.F,lag);

figure(1)
eegplot(res',ch,[],[],[],[]);

%%
load eegplotdat
lags=5*[0 1 2 3 4]%3 5 7 9
figure(2)
IMG=[]
for i=1:length(lags)
    for class=1:3
subplot(3,length(lags),i+(class-1)*length(lags))%,'TightInset',[0 0 0 0]
res=filter2ch(filtersvm.models{class}.F,lags(i));
img=eegplot(res',ch,[1],[],[],[]);
imagesc(img);
IMG((1:397)+397*(class-1),(1:392)+392*(i-1))=img.*mask;
axis off
    end
end

IMG=max(IMG,0);
%% normalisation par classe...

for class=1:3
  IMG((1:397)+397*(class-1),:) =IMG((1:397)+397*(class-1),:)/max(max(IMG((1:397)+397*(class-1),:)));
end

%%

times=(lags)/16;

figure(3)
x=linspace(0.5,3.5,size(IMG,1));
y=linspace(times(2)/2,-times(end)-times(2)/2,size(IMG,2));
imagesc(y,x,(IMG))
map=colormap(gray);
map(1,:)=[0 0 0];
colormap((map))
%colormap('bone')
ylabel('Classes','FontSize',14)
xlabel('delay in s','FontSize',14)
set(gca,'Xtick',[-fliplr(times)],'Ytick',[1 2 3],'Xdir','reverse' )
title(['Discriminative map for subject ' num2str(opt.sub)],'FontSize',14)

posligx=.5*(times(1:4)+times(2:5));

for i=1:4
    line(-[posligx(i) posligx(i)],[0.5  3.5],'Color',[1 1 1],'Linewidth',4)
end

posligy=[1.5 2.5];

for i=1:2
    line([y(1) y(end)],[posligy(i) posligy(i)],'Color',[1 1 1],'Linewidth',6)
end

set(gca,'FontSize',14)
%colormap(hot)
%axis image

%% afficher mulyiples

lags=[1 ]%3 5 7 9
figure(2)
for i=1:length(lags)
    for class=1:3
subplot(3,length(lags),i+(class-1)*length(lags))%,'TightInset',[0 0 0 0]
res=filter2ch(filtersvm.models{class}.F,lags(i));
img=eegplot(res',ch,[],[],[],[]);

axis square
    end
end

%%




%% get channels

         imshow(brain)
         [y x]=ginput(8);
         ch=[x y]; 
         
%%




%%

load example_data
load eegplotdat
mag=exp(0.009.*[1:67]');
test=eegplot(mag,ch,[],[],[],[]);
%figure;imshow(brain);


%%

close all
mag=rand(5,1);
eegplot(mag,[],[],1,'nearest',[]);