% calculs pour la figure de visu de précision selon la taille

%% initialisation

clear all

% validation parameters
opt.nbloop=1;

opt.nbrel=2;
opt.nbtot=2;
d=opt.nbtot;
opt.nbpts=[1000 2000 10000];

opt.noise=2;
opt.noiserand=0;


f=11;

opt.type=4;
opt.f=f;
opt.dephsigs=10;
opt.decy=round(opt.f/2);
opt.nbitermax=20;


% params to validate

opt.cvalues=logspace(1,5,5);
opt.sigmavalues=logspace(-1,2,5);
opt.filtercvalues=logspace(2,4,5);
opt.regnorm2=logspace(1,3,5);
opt.regnorm12=logspace(1,3,5);


opt.seed=1;

opt.todo=[1 1 1 0 0 0];



% classification parameters
options.f=f; % : legth of the filter

options.decy =floor(f/2);%: y time shift...
%options.decy =0;%: y time shift...

options.F=ones(f,d)/(f); %: initialisation of the filter
%options.F=zeros(f,d)/(f); %: initialisation of the filter
%options.F(options.decy,:)=1;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =10 ;%: log informatioouns
options.stopvarx=[0];% : threshold for stopping on F changes
options.stopvarj=[1e-5];
options.usegolden=1;
options.goldensearch_deltmax=.01;
options.goldensearch_stepmax=1;
options.numericalprecision=1e-3;

linear=0;
if linear
    options.kernel='linear';
    options.kerneloption=1;
    options.C = 1e-3; %: C value for svm
    options.regnorm2=1e-2;%[2.25e-2];
    options.regnorm12=0e-3;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
else
    options.kernel='gaussian';
    options.kerneloption=1;
    options.C = 1e3; %: C value for svm
    options.regnorm2=1e2;%[2.25e-2];
    options.regnorm12=0e2;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
end

opt.options=options;


filename=  GetToyFilename(opt);


%% loop

nbtot=[2]% 5 10 20 30 40 50];


for i=1:length(nbtot)
    
    opt.nbtot=nbtot(i);
    CalcToyResults(opt)
    
end


%% getresults

