function DF=gradF_gaussian(X,alphay,F,options)
% gradient of F for filtersvm for the gaussian kernel!

Xt=mfilter(F,X);


    pos=find(alphay);

    Xt=Xt(pos,:);
    alphay=alphay(pos,:);

    %
    K=svmkernel(Xt,options.kernel,options.kerneloption);

    f=size(F,1);
    d=size(F,2);

    DF=zeros(f,d);
    for j=1:d
        Mx=repmat(Xt(:,j),1,size(Xt,1));
        %MXto=MXtp';
        Mx=Mx-Mx';
        for i=1:f

       
            Xp=DecalageSignal(X(:,j),(i-1));
            Xp=Xp(pos);

            MXp=repmat(Xp,1,length(Xp));
            %MXo=repmat(Xp',length(Xp),1);
           % MXo= MXp';

            M=K.*(MXp-MXp').*(Mx);

            DF(i,j)=0.5/options.kerneloption^2*alphay(:)'*(M*alphay(:));
        end
    end