function DF=lgradFpsd(X,Y,w,w0,F,t,verbose)

if nargin<7
    verbose=0;
end;

if nargin<6
    n0=0;
end;

[Xpsd,Xfilt]=get_F_PSD(F,X,t);


f=size(F,1);
d=size(F,2);

DF=zeros(f,d);

for i=1:f
    for j=1:d
        
xdec=DecalageSignalcycl(X(:,j),(i-1));
xfdec=DecalageSignalcycl(Xfilt(:,j),(i-1));

part1=w(j)*Y.*xdec.*xfdec.*max(0,(1-Y.*(Xpsd*w+w0)));

%res=-sum(part1.*sel);
DF(i,j)=-sum(filter(ones(t,1),1,part1));
    end
end