function DF=lgradFsel(X,Y,w,w0,F,sel,selsparse,verbose)

if nargin<8
    verbose=0;
end;

if nargin<6
    n0=0;
end;

if selsparse~=0
    Xt=GetFiltTimeSamples(F,X,sel);
else
    Xt=mfilter(F,X);
    Xt=Xt(sel,:);
end


f=size(F,1);
d=size(F,2);

DF=zeros(f,d);

for i=1:f
    for j=1:d
        if verbose==1 
            %fprintf('Gradient dimension:(%d,%d)\n',i ,j) ;
        end
        DF(i,j)=lgradFijsel(i,j,X,Xt,w,w0,Y,sel,selsparse) ;
    end
end