function [ypredval]=lfilterregressionval(X,sigsvm,opts)
% function returning  the labeling of a signal for a given signal svm
% decision function

if nargin<3
    opts=struct;
end

if ~isfield(opts,'sel'); options.sel=[]; end
if ~isfield(sigsvm,'r'); sigsvm.r=0; end
if ~isfield(sigsvm,'multiclass'); sigsvm.multiclass=0; end


    if sigsvm.multiclass==0

        if nargin<3
            F=sigsvm.F;
        end

%        Xt=mfilter(F,X);

    f=size(sigsvm.F,1);
%     
%     if sigsvm.method==0
%         
%            Xt=mfilter(F,X);
% 
%            ypredval=lsvmval(Xt,sigsvm.w,sigsvm.w0);
%            
%             ypredval=DecalageSignal(ypredval,-sigsvm.decy-sign(sigsvm.decy));
%         
%     else
        
        
        M=sigsvm.F.*repmat(sigsvm.w',f,1);
      ypredval=time_delay_embedding(X,f,sigsvm.decy)*M(:)+sigsvm.w0;
    
 %   end

        %keyboard
  %      ypredval=DecalageSignal(y,-sigsvm.decy);
        % if ~isempty(opts.sel)
        %     ypredval=ypredval(opts.sel);
        % end
     %   ypred=sign(ypredval);

    else

        ypredval=zeros(size(X,1),sigsvm.nbclass);
        switch sigsvm.multiclass

            case 1 % one against all


                for i=1:sigsvm.nbclass

                    [ypredval(:,i)]=lfilterregressionval(X,sigsvm.models{i});


                end

       %         [temp,ypred]=max(ypredval,[],2);

        end

    end

