% test de la fonction d'apprentissage de filtre...

%% génération données

clear all
close all
nbpts=10000;
nbptste=10*nbpts;
nbclass=2;
d=2;
nbbruit=0;
nbrel=d;

% noise of the 
sigmanoise=0;
sigmanoise2=0.5

seed=1985;
rand('seed',seed);
randn('seed',seed);

sigmanoise=sigmanoise2+sigmanoise*rand(d,1);


opts.type=7;
opts.cmean=100;
opts.csigma=10;
%opts.filter=([1:floor(tfilt/2) floor(tfilt/2):-1:1 ])'/sum(([1:floor(tfilt/2) floor(tfilt/2):-1:1 ]))%ones(tfilt,1)/tfilt;
opts.params=[2*(1:nbclass)'-nbclass-1 ones(nbclass,d)*diag(sigmanoise)];
opts.param=1;
opts.dephsigs=6;
opts.d=d;
opts.w=5e-3;
opts.sigmanoisebf=3;
opts.keepswitch=1;
opts.filter=ones(1,20);%randn(1,5)%ones(1,20);
opts.filter=[cos(pi*(1:10)) ones(1,10)]/20;%randn(1,5)%ones(1,20);
opts.w7=[.1,.2];

% rampe: (cumsum(rand(1,20))+0.1*randn(1,20))/20
% bordel: (randn(1,20))/20; (attention au bruit hf


% taoy data generation
[x,Y,xte,Yte]=GernerSig(nbpts,nbptste,nbclass,opts);

[x,mx,vx]=gnormalise(x);
xte=(xte-ones(size(xte,1),1)*mx)./(ones(size(xte,1),1)*vx);

Y=2*Y-3;
Yte=2*Yte-3;
d=d+nbbruit;

X2=x;
X2te=xte;
X=[x randn(size(x,1),nbbruit) ];
Xte=[xte randn(size(xte,1),nbbruit) ];
Yt=Y; 


errssvm=[];
errsssvm=[];
sparsessvm=[];

%figure,plotclassestime(X,Y) 
win=2;
[xtest1 xtest2]  = meshgrid([-1:.05:1]*win,[-1:0.05:1]*win); 
nn = length(xtest1); 
xtest = [reshape(xtest1 ,nn*nn,1) reshape(xtest2 ,nn*nn,1) zeros(nn*nn,nbbruit)]; 


    



%% options non linear
%      svm svm0 tde_svm filtersvm
todo=[];

f=21;
t=20;


options.f=f; % : legth of the filter
options.t=t;
options.r=0;

options.decy =floor(f/2);%: y time shift...
%options.decy =0;%: y time shift...

options.F=ones(f,d)/(f); %: initialisation of the filter
%options.F=zeros(f,d)/(f); %: initialisation of the filter
%options.F(options.decy+1,:)=1;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =20 ;%: log informatioouns
options.stopvarx=[0];% : threshold for stopping on F changes
options.stopvarj=[1e-7];
options.goldensearch_deltmax=.01;
options.goldensearch_stepmax=1;
options.numericalprecision=1e-5;
options.linesearch=0;
options.ls_tol=1e-3;




linear=1;
if linear
    options.kernel='linear';
    options.kerneloption=1;
    options.C = 1e3; %: C value for svm
    options.regnorm2=1e1;%[2.25e-2];
    options.regnorm12=0e-3;%[2.25e-2];
    options.regnormdiff=0e4;
    options.solver=4;
    options.use_cg=1;
else
    options.kernel='gaussian';
    options.kerneloption=1;
    options.C = 1e4; %: C value for svm
    options.regnorm2=1e3;%[2.25e-2];
    options.regnormdiff=0e3;
    options.regnorm12=0e2;%[2.25e-2];
    options.solver=4;
    options.use_cg=1;
end


%options.sel=rand(nbpts,1)<0.1;
%options.selsparse=1;

%Xsel=X(options.sel,:);
%Ysel=Y(options.sel);
% sans filtrage
%[svm,obj]=svmclass2(Xsel,Ysel,options)

% avec filtrage
[svmf,obj]=svmclass2(get_F_PSD(options.F,X,options.t),Y,options)

% Time Delay ERmbedding
%[svm_tde,obj]=svmclass2(time_delay_embedding(X,options),Y,options)

% Time Delay ERmbedding
%[svm_tdeas,obj]=adaptivescaling_svmclass2(time_delay_embedding(X,options),Y,options)

tic
profile on
[sigsvm,LOG]=psdsvmclass(X,Y,options);
profile off
toc

%profile report


% svm
%ysvm=svmval2(Xte,svm);
%precsvm=get_precision(Yte,ysvm)

% moyenneur
%[ypred,yval]=filtersvmval(Xte,LOG);
[ypred,yval]=svmval2(get_F_PSD(options.F,Xte,options.t),svmf);
prec0=get_precision(Yte,ypred)

% time delay embedding
%[ypred,yval]=svmval2(time_delay_embedding(Xte,options),svm_tde);
%prec_tde=get_precision(Yte,ypred)

% time delay embedding
%[ypred,yval]=svmval2(time_delay_embedding(Xte,options),svm_tdeas);
%prec_tdeas=get_precision(Yte,ypred)

% optimal
[ypred,yval]=psdsvmval(Xte,sigsvm);
prec=get_precision(Yte,ypred)




%% visu filtre
figure(12)
nbpoints=201;
subplot(2,1,1)
plot(sigsvm.F(:,:))
title('Filtre optimal')

subplot(2,1,2)
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(sigmanoise*randn(1,length(Y))/length(Y),nbpoints))),'Color',[.5 .5 .5]);



hold on
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(Y'/length(Y),nbpoints))),'m');
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(sigsvm.F(:,:)/options.f,nbpoints))));
hold off
legend('FFt Y','F(:,1)')
title('FFt filtre optimal (fréquences normalisées)')

%% visu fft 2
figure(112)

nbpoints=200;

%abs(fftshift(fft(sigmanoise(1)*randn(length(Y),1)/length(Y),nbpoints)))
k=0.05

subplot(2,1,1)

plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(Y'/length(Y),nbpoints))),'m');
hold on
plot(linspace(-1/2,1/2,nbpoints),sigmanoise(1)*ones(1,nbpoints)/nbpoints,'Color',[.5 .5 .5]);
title('Fourier transform of the label sequence Y')
legend('|fft(Y)|','noise level')
hold off

subplot(2,1,2)

plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(sigsvm.F(:,:)/options.f,nbpoints))));

%legend('|fft(Y)|','|fft(F(:,1))|','|fft(F(:,2))|','noise level')
title('Fourier transform for the optimal filters')
legend('|fft(F(:,1))|','|fft(F(:,2))|')

%% visu convolution...
figure(13)
nbpoints=1000;
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(sigsvm.F(:,1)/norm(sigsvm.F(:,1)),nbpoints))));

hold on
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(opts.filter/norm(opts.filter),nbpoints))),'r');
%plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(opts.filter/norm(opts.filter),nbpoints).*fft(sigsvm.F(:,1)'/norm(sigsvm.F(:,1)),nbpoints))),'g');
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(Y'/norm(Y),nbpoints))),'m');
plot(linspace(-1/2,1/2,nbpoints),abs(fftshift(fft(opts.filter/norm(opts.filter),nbpoints).*fft(Y'/norm(Y),nbpoints))),'c');

hold off
legend('Optimal Filter','Convolutionnal noise','Y','Y*noise')%,'Filter*noise'
title('abs(FFt) des filtres') 



%% visu AUC

figure(36)
plot(precsvm.fpr,precsvm.tpr,'k');

hold on;
plot(prec0.fpr,prec0.tpr,'b');
plot(prec.fpr,prec.tpr,'r');
plot(prec_gmm.fpr,prec_gmm.tpr,'c');
plot(prec_gmmfilter.fpr,prec_gmmfilter.tpr,'g');

hold off
title('AUC')
legend('SVM','AVG-SVM','FilterSVM','GMM','FilterGMM')
axis square

%% visu marrante


figure(1),plotclassestime(Xte,Yte),title('X,Y')
figure(2),plotclassestime(mfilter(sigsvm,Xte),Yte),title('X filtré,Y')

