function [ypredval,ypred]=rfiltersvmval(X,sigsvm)
% function returning  the labeling of a signal for a given signal svm
% decision function

if ~isfield(sigsvm,'multiclass'); sigsvm.multiclass=0; end


if sigsvm.multiclass==0

if nargin<3
    F=sigsvm.F;
end

Xt=mfilter(F(sigsvm.nbclass+1:end),X);

f=size(F,1);

ypast=zeros(f,sigsvm.nbclass);

Fy=F(:,1:sigsvm.nbclass);

y=zeros(size(X,1),1);

for i=1:size(X,1)
    
    ytemp=sum(Fy.*ypast);    
if isempty(sigsvm.xsup) %&& strcmp(sigsvm.kernel,'linear')
    y(i)=lsvmval([ ytemp Xt(i,:)],sigsvm.w,sigsvm.w0);
else
    y(i)=svmval([ ytemp Xt(i,:)],sigsvm.xsup,sigsvm.w,sigsvm.w0,sigsvm.kernel,sigsvm.kerneloption,1);
end

    ypast=circshift(ypast,1);
    ypast(1,:)=[-y(i) y(i)];
    
end




%keyboard
ypredval=DecalageSignal(y,-sigsvm.decy);
ypred=sign(ypredval);

else
   
    
    ypredval=zeros(size(X,1),sigsvm.nbclass);
    
    
    switch sigsvm.multiclass

        case 1 % one against all


            for j=1:sigsvm.nbclass
                
       
                [ypredval(:,j)]=rfiltersvmval(X,sigsvm.models{i});
                

            end
            
            [temp,ypred]=max(ypredval,[],2);

    end
    
end