function [resx]=DecalageSignal(x,tau)
% function wich returns a signal shifted by a tau parameter 
% if tau>0 then x is delayed
% if tau<0 then x is lead


if tau<0
    xt=ones(abs(tau)-1,1)*x(end,:);
    resx=[x(abs(tau):end,:);xt];
else
    xt=ones(tau,1)*x(1,:);
    resx=[xt;x(1:end-tau,:)];
end;

clear xt;