function [resx]=DecalageSignalcycl(x,tau)
% function wich returns a signal shifted by a tau parameter 
% if tau>0 then x is delayed
% if tau<0 then x is lead


if tau<0
    xt=ones(abs(tau)-1,1)*x(end,:);
    resx=[x(abs(tau):end,:);x(1:abs(tau)-1,:)];
else
    xt=ones(tau,1)*x(1,:);
    resx=[x(end-tau+1:end,:);x(1:end-tau,:)];
end;

clear xt;