function X=time_delay_embedding(Xin,opts,decy)

if nargin==2
    f=opts.f;
    decy=opts.decy;
end

if nargin==3
    f=opts;
end

d=size(Xin,2);

X=zeros(size(Xin,1),f*d);

idx=0:f:f*d-1;

for i=1:f
    X(:,idx+i)=circshift(Xin,i-1-decy);
end

if decy>0


    for i=1:f
        for j=1:f-1
            X(j,idx+i)=Xin(1,:);
        end
    end

else

    for i=1:f-1
        for j=0:-1:-f+1
            X(end+j,idx+i)=Xin(end,:);
        end
    end
end

