function plotclasses_hist(ypred,k,nbin,norm)
% plots a histogram graph

if nargin<4
    norm=0;
end

if nargin<3
    nbin=10;
end

style='+o*xsd<>ph';
color= 'rgbcmyk';
%
% color=  [0,0,1;
%     1,0,0;
%     0,.7,0;
%     0,.7,.7;
%     1,0,1;
%     .7,.7,0;
%     0,0,0];



labels=unique(k);



for j=1:size(ypred,2)
    
    
    [rien,vals]=hist(ypred(:,j),nbin);
    
    subplot(size(ypred,2),1,j);
    
    hold on;
for i=1:length(labels)
    
    [h]=hist(ypred(k==labels(i),j),vals);
    
    if norm~=0
       h=h/sum(h); 
    end
    plot(vals,h,color(i))
    
end

hold off


end
    
