function plotclasses_multidim(ypred,k,nbin,norm)
% plots a histogram graph

if nargin<4
    norm=0;
end

if nargin<3
    nbin=10;
end

style='+o*xsd<>ph';
%color= 'rgbcmyk';
%
color=  [0,0,1;
    1,0,0;
    0,.7,0;
    0,.7,.7;
    1,0,1;
    .7,.7,0;
    0,0,0];



labels=unique(k);



for j=1:size(ypred,2)
    for l=1:size(ypred,2)
    
    [rien,vals]=hist(ypred(:,j),nbin);
    
    subplot(size(ypred,2),size(ypred,2),j+(l-1)*size(ypred,2));
    
    
    if l==j
    hold on;
for i=1:length(labels)
    
    [h]=hist(ypred(k==labels(i),j),vals);
    
    if norm~=0
       h=h/sum(h); 
    end
    plot(vals,h,'Color',color(i,:))
    
end

hold off

    else
        plotclasses(ypred(:,[j l]),k)
        
    end


    end
end
    
